<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Models;

use App\Http\Base\BaseModel;
use App\Http\Providers\iam\core\model\OracleOCIConnector;
use Carbon\Carbon;
use App\Http\Models\LokasiitemModel;

class ItempopenerimaanioModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "itempopenerimaanio";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "itempopenerimaanio";

    /**
     * primary key from table remember eloquent doesnt support composite primary key
     */
    protected $primaryKey = "id";
    /**
     * check the incrementing boolean if the incrementing from database is false then the value is false by default
     */
    // public $incrementing = false;
    /**
     * fillable property for eloquent attribute cast
     */
    protected $fillable = [
        "id", "ioNumber", "itemId", "lokasiId", "receiptDate", "dateCreated", "quantity", "lotNumber", "date_updated", "qtyRemaining", "status", "fromLokasiId"
    ];
    /**
     * Creating raw object from table that, this purpose for making you easier for remembering all attribute
     */


    /**
     * paging for default paging purpose
     * if you want to add new paging property you have to add the property in this array
     * you have to add the relation value
     * remember this is not suported casting value you have to handle by your self
     */
    protected $aliasPaging = [
        "id" => "itempopenerimaanio.id",
        "ioNumber" => "itempopenerimaanio.ioNumber",
        "part_number" => "itemId.part_number",
        "itemId" => "itemId.id",
        "namaItem" => "itemId.namaItem",
        "deskripsi" => "itemId.deskripsi",
        "lokasiId" => "lokasiId.id",
        "namaLokasi" => "lokasiId.namaLokasi"
    ];

    /**
     * relation from ' . item . ' by ' . itemId
     * join item on item.id = itempopenerimaanio.itemId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationItemId($alias = "itemId")
    {
        $this->getQuery()->join("item as $alias", "$alias.id", "=", "itempopenerimaanio.itemId");
        return $this;
    }

    /**
     * relation from ' . lokasiitem . ' by ' . itemId
     * join item on item.id = itempopenerimaanio.itemId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationLokasiId($alias = "lokasiId")
    {
        $this->getQuery()->join("lokasiitem as $alias", "$alias.id", "=", "itempopenerimaanio.lokasiId");
        return $this;
    }

    /**
     * relation from ' . popenerimaan . ' by ' . poPenerimaanId
     * join popenerimaan on popenerimaan.ioNumber = itempopenerimaanio.poPenerimaanId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationPoPenerimaanIoId($alias = "poPenerimaanIoId")
    {
        $this->getQuery()->join("popenerimaanio as $alias", "$alias.ioNumber", "=", "itempopenerimaanio.ioNumber");
        return $this;
    }

    public function syncFromOracleHO($syncTable)
    {
        (new LogsyncoracleModel)->setLogSync("Detail Penerimaan IO", Carbon::now()->toDateTimeString(), "", "start");
        echo "start sync item po penerimaan io data from oracle", PHP_EOL;
        $oracleOCI = new OracleOCIConnector();
        $oracleOCI->getConnection()->select(self::getOracleQuery($syncTable, 0, 0))->execute();
        $lastUpdate = $syncTable->last_sync;
        while (($rows = $oracleOCI->fetchAll()) !== false) {
            $item = new self();
            $item->storingDataFromOracle($rows);
            if (!empty($rows->LAST_UPDATE_DATE)) $lastUpdate = $rows->LAST_UPDATE_DATE;
            $syncTable = \App\Http\Models\SyncUtilities\StagingSyncTableModel::find($syncTable->id);
            $syncTable->last_sync = $lastUpdate;
            $syncTable->update();
        }
        (new LogsyncoracleModel)->setLogSync("Detail Penerimaan IO", Carbon::now()->toDateTimeString(), "", "success");
        $oracleOCI->closeConnection();
    }

    public static function getOracleQuery($staging, $startRow, $endRow)
    {
        $query = "  SELECT
                      IOV.SHIPMENT_NUMBER,
                      IOV.TO_ORG_ID,
                      IOV.FROM_ORG_ID,
                      IOV.INVENTORY_ITEM_ID,
                      IOV.DATE_INTRANSIT,
                      IOV.QTY,
                      IOV.LAST_UPDATE_DATE,
                      IOV.FROM_SUBINV,
                      IOV.TO_SUBINV,
                      IOV.SEGMENT1,
                      IOV.LOT_NUMBER
                    
                    FROM pelni_iot_v IOV
                    WHERE
                      IOV.LAST_UPDATE_DATE >= TO_DATE('" . Carbon::parse($staging->last_sync)->toDateTimeString() . "', 'yyyy-mm-dd HH24:MI:SS')
                    ORDER BY IOV.LAST_UPDATE_DATE ASC";
        return $query;
    }


    public function mapperOracle($oracle)
    {
        $oracle->TO_SUBINV = strtoupper(trim($oracle->TO_SUBINV));
        $oracle->FROM_SUBINV = strtoupper(trim($oracle->FROM_SUBINV));

        /*  THESE 2 LINES MOVE TO storingDataFromOracle()
        $toLokasi = (new LokasiitemModel())->getQuery()->where("lokasiitem.namaLokasi","=",$oracle->TO_SUBINV);
        $fromLokasi = (new LokasiitemModel())->getQuery()->where("lokasiitem.namaLokasi","=",$oracle->FROM_SUBINV); */

        $this->ioNumber = $oracle->SHIPMENT_NUMBER;
        $this->itemId = $oracle->INVENTORY_ITEM_ID;
        $this->quantity = $oracle->QTY;
        $this->qtyRemaining = $oracle->QTY;
        $this->lokasiId = isset($oracle->toLokasi->id) ? $oracle->toLokasi->id : null;
        $this->fromLokasiId = isset($oracle->fromLokasi->id) ? $oracle->fromLokasi->id : null;
        $this->lotNumber = $oracle->LOT_NUMBER;
        $this->date_updated = $oracle->LAST_UPDATE_DATE;
        $this->status = 0;
    }

    public function storingDataFromOracle($oracle)
    {
        $oracle->toLokasi = (new LokasiitemModel())->getQuery()->where("lokasiitem.namaLokasi", "=", $oracle->TO_SUBINV)->first();
        $oracle->fromLokasi = (new LokasiitemModel())->getQuery()->where("lokasiitem.namaLokasi", "=", $oracle->FROM_SUBINV)->first();

        $modelExists = (new self())->getQuery()->where("itempopenerimaanio.ioNumber", "=", $oracle->SHIPMENT_NUMBER)
            ->where("itempopenerimaanio.itemId", "=", $oracle->INVENTORY_ITEM_ID)
            ->where("itempopenerimaanio.lotNumber", "=", $oracle->LOT_NUMBER)
            ->first();

        if (!$modelExists) {
            try {
                $model = new self();
                $model->mapperOracle($oracle);
                $model->save();
                (new LogsyncoracleModel)->setLogSync("Detail Penerimaan IO : " . $model->ioNumber . " - " . $oracle->SEGMENT1, Carbon::now()->toDateTimeString(), "", "inserted");
                echo $model->ioNumber . " inserted ", PHP_EOL;
            } catch (\Exception $exception) {
                // FUNCTION TO INSERT INTO SYNCERROR TABLE IN CASE THE PROCESS ABOVE HAS SOME ERROR
                $params = json_encode([
                    "SHIPMENT_NUMBER" => $oracle->SHIPMENT_NUMBER,
                    "TO_ORG_ID" => $oracle->TO_ORG_ID,
                    "FROM_ORG_ID" => $oracle->FROM_ORG_ID
                ]);
                $data = json_encode($oracle);
                (new SyncerrorModel)->saveError("pelni_iot_v", $params, $data, "HO");

                echo $exception->getMessage(), PHP_EOL;
                // FUNCTION TO INSERT INTO LOGSYNCHO TABLE IN CASE THE PROCESS ABOVE HAS SOME ERROR
                (new LogsyncoracleModel)->setLogSync("Detail Penerimaan IO : " . $model->ioNumber . " - " . $oracle->SEGMENT1, Carbon::now()->toDateTimeString(), $exception->getMessage(), "failed");
            }
        } else {
            $model = self::find($modelExists->id);
            $model->itemId = $oracle->INVENTORY_ITEM_ID;
            $model->quantity = $oracle->QTY;
            $model->lokasiId = isset($oracle->toLokasi->id) ? $oracle->toLokasi->id : null;
            $model->fromLokasiId =  isset($oracle->fromLokasi->id) ? $oracle->fromLokasi->id : null;
            $model->lotNumber = $oracle->LOT_NUMBER;
            $model->date_updated = $oracle->LAST_UPDATE_DATE;
            try {
                $model->update();
                echo $model->ioNumber . " " . $this->getTable() . " updated ", PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Detail Penerimaan IO : " . $model->ioNumber . " - " . $oracle->SEGMENT1, Carbon::now()->toDateTimeString(), "", "updated");
            } catch (\Exception $exception) {
                echo $exception->getMessage(), PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Detail Penerimaan IO : " . $model->ioNumber . " - " . $oracle->SEGMENT1, Carbon::now()->toDateTimeString(), $exception->getMessage(), "failed");
            }
        }
    }

    public function syncItemFromOracleHO($ioNumber)
    {
        (new LogsyncoracleModel)->setLogSync("Detail Penerimaan IO", Carbon::now()->toDateTimeString(), "", "start");
        echo "start sync item po penerimaan io data from oracle", PHP_EOL;
        $oracleOCI = new OracleOCIConnector();
        $oracleOCI->getConnection()->select(self::getOracleQueryItem($ioNumber))->execute();
        while (($rows = $oracleOCI->fetchAll()) !== false) {
            $item = new self();
            $item->storingDataFromOracle($rows);
        }
        (new LogsyncoracleModel)->setLogSync("Detail Penerimaan IO", Carbon::now()->toDateTimeString(), "", "success");
        $oracleOCI->closeConnection();
    }

    public static function getOracleQueryItem($ioNumber)
    {
        $query = "  SELECT
                      IOV.SHIPMENT_NUMBER,
                      IOV.TO_ORG_ID,
                      IOV.FROM_ORG_ID,
                      IOV.INVENTORY_ITEM_ID,
                      IOV.DATE_INTRANSIT,
                      IOV.QTY,
                      IOV.LAST_UPDATE_DATE,
                      IOV.FROM_SUBINV,
                      IOV.TO_SUBINV,
                      IOV.SEGMENT1,
                      IOV.LOT_NUMBER                    
                    FROM pelni_iot_v IOV
                    WHERE IOV.SHIPMENT_NUMBER = '" . $ioNumber . "'";
        return $query;
    }
}
